// addin.cpp : Implementation of Caddin
#include "stdafx.h"
#include "OutlookAddin.h"
#include "addin.h"


#include "spdm/common/DeviceManager.h"
#include "spdm/common/DeviceManagerFactory.h"

#define APPLICATION_URI TEXT("Funambol")
#define INSTALL_DIR     TEXT("installDir")
#define PROGRAM_NAME    TEXT("Sync4j Outlook Client.exe")
#define CONTEXT         TEXT("Funambol\\SyncClientOutlook")
#define APP_NAME        "Sync4j Outlook Client"
#define TOOLTIP         OLESTR("Synchronize")
#define CAPTION         OLESTR("Sync4j Outlook Client")
#define S4J             "s4j"
#define OLESTR_S4J      OLESTR("s4j")
#define WINDOW_NAME     TEXT("Sync4j Outlook Client")
#define SYNCHRONIZATION OLESTR("Synchronization")
#define SYNC4J          OLESTR("Sync4j")
#define AMP_SYNC4J      TEXT("&Sync4j")
#define CONFIGURATION   OLESTR("Configuration")
#define OUTLOOK         TEXT(" outlook")  // note the space before outlook. It's important 'cause it's used as command line argument too.



STARTUPINFO         si;
PROCESS_INFORMATION pi;
DWORD   processId;

_CommandBarButtonPtr s4jPtr;	
_CommandBarButtonPtr s4jPtrItem;
_CommandBarButtonPtr s4jPtrConfig;

/////////////////////////////////////////////////////////////////////////////
// Caddin
_ATL_FUNC_INFO OnClickButtonInfo ={CC_STDCALL,VT_EMPTY,2,{VT_DISPATCH,VT_BYREF | VT_BOOL}};
_ATL_FUNC_INFO OnClickSynchronizationInfo ={CC_STDCALL,VT_EMPTY,2,{VT_DISPATCH,VT_BYREF | VT_BOOL}};
_ATL_FUNC_INFO OnClickConfigurationInfo ={CC_STDCALL,VT_EMPTY,2,{VT_DISPATCH,VT_BYREF | VT_BOOL}};

STDMETHODIMP Caddin::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_Iaddin
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}


STDMETHODIMP Caddin::OnConnection(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch * AddInInst, SAFEARRAY * * custom) {
	 
     m_pParentApp = Application;
   
     if (ConnectMode != ext_cm_Startup)
        OnStartupComplete(custom);

    return S_OK;
}


void copyIconIntoClip() {
        HICON hIco =(HICON)::LoadImage(_Module.GetResourceInstance(), 
        MAKEINTRESOURCE(IDI_ICON1),IMAGE_ICON,0,0,LR_LOADTRANSPARENT |  LR_LOADMAP3DCOLORS);    
        ICONINFO oIconInfo;
        GetIconInfo(hIco, &oIconInfo);

        // put Icon into Clipboard 
        ::OpenClipboard(NULL); 
        ::EmptyClipboard();     
        ::SetClipboardData(CF_BITMAP, oIconInfo.hbmColor);  
        ::CloseClipboard(); 
        ::DeleteObject(hIco); 

}

STDMETHODIMP Caddin::OnStartupComplete(LPSAFEARRAY* custom) {
    
    CComVariant vEmpty(DISP_E_PARAMNOTFOUND, VT_ERROR);
	    
    _ApplicationPtr spApp(m_pParentApp);    
    _ExplorerPtr    spExplorer;
    CComPtr < Office::_CommandBars> spCmdBars;
    CComPtr < Office:: CommandBar>  spCmdBar;
    CommandBarControlPtr commandBarControlPtr;
    
    s4jPtr       = NULL;	
    s4jPtrItem   = NULL;
    s4jPtrConfig = NULL;

    spApp->ActiveExplorer(&spExplorer);
    applicationPtr = spApp;
    
	HRESULT hRes = spExplorer->get_CommandBars(&spCmdBars); 
    
    if(FAILED(hRes)) {
        return hRes;
    }
        
	if (SUCCEEDED(spCmdBars->get_Item(CComVariant(APP_NAME),&spCmdBar))) {
		
		commandBarControlPtr = spCmdBar->FindControl(CComVariant(msoControlButton), 
                                                     vEmpty, 
                                                     CComVariant(S4J),
                                                     VARIANT_FALSE, 
                                                     VARIANT_FALSE);

		_CommandBarButtonPtr _commandBarButtonPtr(commandBarControlPtr);

		s4jPtr = _commandBarButtonPtr;        
        HRESULT h = 0;        
        
        if (h < 0) {
			return h;        
        }
		s4jPtr->Enabled = TRUE;	
        
        //
        // check if sync4j bar exists
        //

        CComPtr < Office::CommandBarControls> spCmdCtrls;
        CComPtr < Office::CommandBarControl> spCmdCtrl;        
        
        spCmdCtrls = spCmdBars->ActiveMenuBar->GetControls(); 
        ATLASSERT(spCmdCtrls);       
        
        h = spCmdCtrls->get_Item(CComVariant(AMP_SYNC4J), &spCmdCtrl); 
        
        if (SUCCEEDED(h)) {            
            CommandBarPopupPtr pMenuItem;             
            pMenuItem = spCmdBars->ActiveMenuBar->Controls->GetItem(AMP_SYNC4J);            
            s4jPtrItem   = pMenuItem->Controls->GetItem(SYNCHRONIZATION);             
            s4jPtrConfig = pMenuItem->Controls->GetItem(CONFIGURATION);
            
            
        } else {
            // there is no sync4j bar
            AddNewMenubar(spCmdBars);
        }

    } else {

        // now we add a new toolband to Outlook
	    CComVariant vName(APP_NAME); 
	    CommandBarPtr spNewCmdBar; 
	    
	    CComVariant vPos(1); 
	    CComVariant vTemp(VARIANT_FALSE); 	
	    
	    // Add a new toolband through Add method
	    spNewCmdBar = spCmdBars->Add(vName, vPos, vEmpty, vTemp); 
	    spNewCmdBar->Protection = msoBarNoCustomize;

	    //now get the toolband's CommandBarControls
        CComPtr < Office::CommandBarControls> spBarControls;
	    spBarControls = spNewCmdBar->GetControls();
	    
	    //MsoControlType::msoControlButton = 1
	    //CComVariant vToolBarType(1);
        CComVariant vToolBarType(msoControlButton);
        
	    //show the toolbar?
	    CComVariant vShow(VARIANT_FALSE);
	    
        CComPtr < Office::CommandBarControl> spNewBar;
        CComPtr < Office::CommandBarControl> spNewBarConfig;
        
        // Add first button
	    spNewBar = spBarControls->Add(vToolBarType, vEmpty, vEmpty, vEmpty, vShow); 
        

        // get CommandBarButton interface for each toolbar button
	    // so we can specify button styles and stuff
	    // each button displays a bitmap and caption next to it	
    
        CComQIPtr < Office::_CommandBarButton> spCmdButton(spNewBar);
 
        // to set a bitmap to a button, load a 32x32 bitmap 
        // and copy it to clipboard. Call CommandBarButton's PasteFace() 
        // to copy the bitmap to the button face. to use 
        // Outlook's set of predefined bitmap, set button's FaceId to //the 
        // button whose bitmap you want to use 
    
        //
        // Modified to load an ICON
        // 
        spCmdButton->BeginGroup = true;
        spCmdButton->PutStyle(msoButtonIcon);	    
        copyIconIntoClip();
    
        // set style before setting bitmap

        hRes = spCmdButton->PasteFace();
        if (hRes < 0) {
	        spCmdButton->PutFaceId(1758);
        }
    
	    spCmdButton->PutVisible(VARIANT_TRUE); 
	    spCmdButton->PutCaption(CAPTION); 
	    spCmdButton->PutEnabled(VARIANT_TRUE);
	    spCmdButton->PutTooltipText(TOOLTIP); 
	    spCmdButton->PutTag(OLESTR_S4J); 

	    s4jPtr = spCmdButton;
        HRESULT hr = 0;	    
        
	    if (FAILED(hRes))
		    return hRes;

	    spNewCmdBar->PutVisible(VARIANT_TRUE);	
	    s4jPtr->Enabled = true; 
        
        
        //
        // to add the sync4j menu
        //

        CComPtr < Office::CommandBarControls> spCmdCtrls;
        CComPtr < Office::CommandBarControl> spCmdCtrl;        
        
        spCmdCtrls = spCmdBars->ActiveMenuBar->GetControls(); 
        ATLASSERT(spCmdCtrls);       
        
        hr = spCmdCtrls->get_Item(CComVariant(AMP_SYNC4J), &spCmdCtrl); 

        if (FAILED(hr)) {
            // there is no sync4j bar
            AddNewMenubar(spCmdBars);
            
        } else {
            CommandBarPopupPtr pMenuItem; 
            pMenuItem = spCmdBars->ActiveMenuBar->Controls->GetItem(AMP_SYNC4J);// or "&Tools"
            s4jPtrItem   = pMenuItem->Controls->GetItem(SYNCHRONIZATION); 
            s4jPtrConfig = pMenuItem->Controls->GetItem(CONFIGURATION);
            // MessageBox (NULL, TEXT("existing bar"), TEXT ("Debug eVC: Found 0"), MB_SETFOREGROUND |MB_OK);
        }        

    }
    
    DispAdviseControls();
    
	return S_OK;
}


STDMETHODIMP Caddin::OnDisconnection(ext_DisconnectMode RemoveMode, SAFEARRAY * * custom)
{
   
    HRESULT hRes = 0; 
    
    if (RemoveMode == 1) {
        CComVariant vEmpty(DISP_E_PARAMNOTFOUND, VT_ERROR);           
        _ExplorerPtr    spExplorer;
        CommandBarPtr commandBarPtr;
        applicationPtr->ActiveExplorer(&spExplorer);

        _CommandBarsPtr spCmdBars; 

        hRes = spExplorer->get_CommandBars(&spCmdBars);
        if(FAILED(hRes)) {
            return hRes;
        }	   

	    hRes = spCmdBars->get_Item(CComVariant(APP_NAME),&commandBarPtr);
	    if (SUCCEEDED(hRes))
	    {
		    // get the Button
		    CommandBarControlPtr commandBarControlPtr;
		    commandBarControlPtr = commandBarPtr->FindControl(CComVariant(msoControlButton),vEmpty,CComVariant(S4J),VARIANT_FALSE,VARIANT_FALSE);
		    if (commandBarControlPtr != NULL)
		    {
			    commandBarControlPtr->Delete();
		    }
		    commandBarPtr->Delete();
	    }
        DeleteMenubar(spCmdBars);
    }
    
    // hRes = DispEventUnadvise((IDispatch*)s4jPtr);
    hRes = DispUnadviseControls();
	if(FAILED(hRes)) {		
        return hRes;
    }

	return S_OK;
}

STDMETHODIMP Caddin::OnBeginShutdown(SAFEARRAY ** custom) {    
    
    return S_OK;
}


void __stdcall Caddin::OnClickSynchronization(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault) {

    launchSyncClientOutlook(OUTLOOK);
}

void __stdcall Caddin::OnClickConfiguration(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault) {

    launchSyncClientOutlook(NULL);
}



//---------------------------------------------------------------------------
void __stdcall Caddin::OnClickButton(IDispatch* /*Office::_CommandBarButton* */ Ctrl, VARIANT_BOOL * CancelDefault)
{   
     
    //
    // Test if arleady exists a window named "SyncClient Outlook" with the same process id.
    // If there is, put in foreground else create a new one
    //   
    launchSyncClientOutlook(OUTLOOK);
    	
}

/*
* If paramenter equals "outlook" then the method was lauched by the Configuration Item
* If it has "outlook" the button or the item that start sync in background
*/

void Caddin::launchSyncClientOutlook(wchar_t* parameter) {
    
    HWND hwnd = FindWindow(NULL, WINDOW_NAME);
    if (hwnd != NULL) {
       
        HANDLE h = OpenProcess(PROCESS_ALL_ACCESS, FALSE, processId);
        if (h != NULL) {            
            SetForegroundWindow(hwnd);
            CloseHandle(h);
            CloseHandle(hwnd); 
            return;
        }
        CloseHandle(hwnd);                
    }
    
    wchar_t buf[512];
    wchar_t program [512];
    
    wchar_t PATH [64];
    wsprintf(PATH, TEXT("%s"), INSTALL_DIR);

    DeviceManagerFactory factory = DeviceManagerFactory();
    DeviceManager* dm = factory.getDeviceManager();
    ManagementNode* spdsConfig = dm->getManagementNode(CONTEXT);
    spdsConfig->getPropertyValue(PATH, buf, 512);        
    
    wsprintf(program, TEXT("%s\\%s"), buf, PROGRAM_NAME);
    
    //
    // Add the command line "outlook" to the SyncClientOutlook.exe
    //
    if (parameter != NULL && wcscmp(parameter, OUTLOOK) == 0) {
        wcscat(program, OUTLOOK);
    }
    
    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );
    BOOL res = FALSE;
    // Start the child process. 

    SetCurrentDirectory(buf);
    res = CreateProcess( NULL,   // No module name (use command line).
        program,
        NULL,             // Process handle not inheritable.
        NULL,             // Thread handle not inheritable.
        FALSE,            // Set handle inheritance to FALSE.
        0,                // No creation flags.
        NULL,             // Use parent's environment block.
        NULL,             // Use parent's starting directory.
        &si,              // Pointer to STARTUPINFO structure.
        &pi );            // Pointer to PROCESS_INFORMATION structure.
    
    processId = pi.dwProcessId;
 
    // Close process and thread handles.
    CloseHandle( pi.hProcess );
    CloseHandle( pi.hThread );  

}

HRESULT Caddin::DeleteMenubar(_CommandBars *pCmdBars) {
    
    CComPtr < Office::CommandBarControls> spCmdCtrls;
    CComPtr < Office::CommandBarControl> spCmdCtrl;        

    spCmdCtrls = pCmdBars->ActiveMenuBar->GetControls(); 
    ATLASSERT(spCmdCtrls);       

    HRESULT hr = spCmdCtrls->get_Item(CComVariant(AMP_SYNC4J), &spCmdCtrl); 

    if (SUCCEEDED(hr)) {
        CommandBarPopupPtr pMenuItem; 
        pMenuItem = pCmdBars->ActiveMenuBar->Controls->GetItem(AMP_SYNC4J);// or "&Tools"
        pMenuItem->Delete(vtMissing);

    } 

    return S_OK;
}


HRESULT Caddin::AddNewMenubar(_CommandBars *pCmdBars)
{
    CComPtr < Office::CommandBar > spNewCmdBar;
    HRESULT hr = pCmdBars->get_ActiveMenuBar(&spNewCmdBar);
    if (FAILED(hr))
        return hr;
    
    CComPtr< Office::CommandBarControls > spCtrls; 
    spCtrls = spNewCmdBar->GetControls(); 
    ATLASSERT(spCtrls);

    CComVariant varType(10);
    CComVariant vtEmpty(DISP_E_PARAMNOTFOUND, VT_ERROR);
    //CComVariant vtId(1001); // id
    CComVariant vtTemp(VARIANT_FALSE);
    //CComVariant vtBefore(7);
    CComPtr< CommandBarControl > spCtrl;
    spCtrl = spCtrls->Add(varType, vtEmpty, vtEmpty, vtEmpty, vtTemp);

    ATLASSERT(spCtrl);
    
    CComQIPtr< Office::CommandBarPopup > spPopup(spCtrl->GetControl());
    ATLASSERT(spPopup);
    
    // set menu caption
    spPopup->PutCaption(SYNC4J);
    spPopup->PutVisible(VARIANT_TRUE);
    
    // now add a menu item to the menubar
    // as a CommandBarButton so you can specify styles
     
    CComPtr< Office::CommandBarControls > spCmdBarCtrls; 
    spCmdBarCtrls = spPopup->GetControls(); 
    
    // A menu is a CommandBarPopup 
    // object(MsoControlType::msoControlPopup = 10), 
    // to which we have to add our menuitems i.e. 
    // CommandBarButton(MsoControlType::msoControlButton = 1).
    // you can also add popup menus similarly.
    
    CComVariant vType(1); // button

    //
    // Button Synchronization
    //

    CComPtr< Office::CommandBarControl > spBarCtrl; 
    
    spBarCtrl = spCmdBarCtrls->Add(vType, vtEmpty, vtEmpty, vtEmpty, vtTemp); 
    ATLASSERT(spBarCtrl);
        
    CComQIPtr< Office::_CommandBarButton > spButton(spBarCtrl);
    ATLASSERT(spButton);
    
    // set button styles
    spButton->PutCaption(SYNCHRONIZATION);
    copyIconIntoClip();
    
    spButton->PasteFace();
    spButton->PutStyle(Office::msoButtonIconAndCaption);
    spButton->PutVisible(VARIANT_TRUE); 
    
    s4jPtrItem = spButton;
    
    //
    // Button configuration
    //

    CComPtr< Office::CommandBarControl > spBarCtrlConfig; 
    
    spBarCtrlConfig = spCmdBarCtrls->Add(vType, vtEmpty, vtEmpty, vtEmpty, vtTemp); 
    ATLASSERT(spBarCtrl);
        
    CComQIPtr< Office::_CommandBarButton > spButtonConfig(spBarCtrlConfig);
    ATLASSERT(spButtonConfig);
    
    // set button styles
    spButtonConfig->PutCaption(CONFIGURATION);
    //spButtonConfig->PutFaceId(0);
    //spButtonConfig->PutStyle(Office::msoButtonIconAndCaption);
    spButtonConfig->PutStyle(Office::msoButtonCaption);
    spButtonConfig->PutVisible(VARIANT_TRUE); 
    
    s4jPtrConfig = spButtonConfig;

    return S_OK;
}

HRESULT __stdcall Caddin::DispAdviseControls(void)
{
	HRESULT hr = ButtonSyncEvent::DispEventAdvise((IDispatch*)s4jPtr,&DIID__CommandBarButtonEvents);
	if (FAILED(hr))
		return hr;
    
    if (s4jPtrItem != NULL) {
        hr = ItemSynchronizationEvent::DispEventAdvise((IDispatch*)s4jPtrItem,&DIID__CommandBarButtonEvents);
	    if (FAILED(hr))
		    return hr;
    }

    if (s4jPtrConfig != NULL) {
        hr = ItemConfigurationEvent::DispEventAdvise((IDispatch*)s4jPtrConfig,&DIID__CommandBarButtonEvents);
	    if (FAILED(hr))
		    return hr;
    }    
    
	return S_OK;
}

HRESULT __stdcall Caddin::DispUnadviseControls(void)
{
    
	HRESULT hr = ButtonSyncEvent::DispEventUnadvise((IDispatch*)s4jPtr);
    if(FAILED(hr)) {
        return hr;
    }
    if (s4jPtrItem != NULL) {
	    hr = ItemSynchronizationEvent::DispEventUnadvise((IDispatch*)s4jPtrItem);
        if(FAILED(hr)) {
		    return hr;
        }
    }
    if (s4jPtrConfig != NULL) {
        hr = ItemConfigurationEvent::DispEventUnadvise((IDispatch*)s4jPtrConfig);
        if(FAILED(hr)) {
		    return hr;
        }
    }
    return S_OK;
}

